' 

FUNCTION PBmain as LONG

    Open "tmp.bat" for output as #1         ' write the batch file to get the list of C files
      Print #1, "@echo off"
      Print #1, "dir /b *.c > clst.txt"
    Close #1

    Shell "tmp.bat"                         ' run the batch file

    Open "clst.txt" for binary as #1        ' load the list into memory
      Get$ #1, lof(1), txt$
    Close #1

    Open "clst.rsp" for output as #1        ' write the C compiler response file
      Print #1, txt$;
    Close #1

  ' -------------------------------------------------------------
  ' modify the list placing "main.c" at the beginning of the list
  ' -------------------------------------------------------------
    txt$ = "main.c"+$CRLF+remove$(txt$,"main.c"+$CRLF)

  ' -------------------------------------------------
  ' change the file extension to "obj" for the linker
  ' -------------------------------------------------
    Replace ".c" with ".obj" in txt$

    Open "clnk.rsp" for output as #1        ' write the linker response file
      Print #1, txt$;
    Close #1

    Open "makjwasm.bat" for output as #1    ' create the batch file to build JWASM
    Print #1,  _
      "@echo off"+chr$(13,10)+_
      chr$(13,10)+_
      "  :: ----------------------------------"+chr$(13,10)+_
      "  :: Set your build root directory here"+chr$(13,10)+_
      "  :: ----------------------------------"+chr$(13,10)+_
      "     set vcroot=\vctoolkit\"+chr$(13,10)+_
      "   "+chr$(13,10)+_
      "     set include=%vcroot%include\"+chr$(13,10)+_
      "     set lib=%vcroot%lib\"+chr$(13,10)+_
      chr$(13,10)+_
      "  :: -------------"+chr$(13,10)+_
      "  :: SPEED OPTIONS"+chr$(13,10)+_
      "  :: -------------"+chr$(13,10)+_
      "     %vcroot%bin\cl /c /D_STANDALONE_ /D__NT__ /DFASTPASS=1 /Fo /IH /I%include% /Ob2 /O2 /Og /Ot /Ox /G7 @clst.rsp"+chr$(13,10)+_
      chr$(13,10)+_
      "  :: ------------"+chr$(13,10)+_
      "  :: SIZE OPTIONS"+chr$(13,10)+_
      "  :: ------------"+chr$(13,10)+_
      "  :: %vcroot%bin\cl /c /D_STANDALONE_ /D__NT__ /DFASTPASS=1 /Fo /IH /I%include% /O1 /Og /Os /G7 @clst.rsp"+chr$(13,10)+_
      chr$(13,10)+_
      "  :: ----"+chr$(13,10)+_
      "  :: LINK"+chr$(13,10)+_
      "  :: ----"+chr$(13,10)+_
      "     %vcroot%bin\Link /SUBSYSTEM:CONSOLE /OUT:jwasm.exe /libpath:%lib% @clnk.rsp"+chr$(13,10)+_
      chr$(13,10)+_
      "  :: -----------------"+chr$(13,10)+_
      "  :: clean up the mess"+chr$(13,10)+_
      "  :: -----------------"+chr$(13,10)+_
      "     del *.obj"+chr$(13,10)+_
      chr$(13,10)+_
      "  :: ------------------------"+chr$(13,10)+_
      "  :: display the build result"+chr$(13,10)+_
      "  :: ------------------------"+chr$(13,10)+_
      "     dir jwasm.exe"+chr$(13,10)+_
      chr$(13,10)+_
      "pause"
    Close #1

    Shell "makjwasm.bat"                    ' run the batch file to build JWASM

End FUNCTION

' 
